%=============================================================================
% Copyright (c) 2016-present Allan CORNET (Nelson)
%=============================================================================
% This file is part of the Nelson.
%=============================================================================
% LICENCE_BLOCK_BEGIN
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU Lesser General Public
% License as published by the Free Software Foundation; either
% version 2.1 of the License, or (at your option) any later version.
%
% Alternatively, you can redistribute it and/or
% modify it under the terms of the GNU General Public License as
% published by the Free Software Foundation; either version 2 of
% the License, or (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU Lesser General Public License for more details.
%
% You should have received a copy of the GNU Lesser General Public
% License along with this program. If not, see <http://www.gnu.org/licenses/>.
% LICENCE_BLOCK_END
%=============================================================================
function doc(varargin)
  if nargin() > 1
    error(_('Wrong number of input arguments.'));
  end
  if ~indexhelp()
    helpbrowser();
    helpbrowser('-hide', 'bookmarks');
  end
  if nargin() == 1
    name = varargin{1};
    if ~ischar(name)
      error(_('Wrong type for argument #1: string expected.'));
    end
    p = which(name,'-module');
    if isempty(p)
      helpbrowser('-name', name);
    else
      if length(p) == 1
        id = [p{1}, '::', name];
        helpbrowser('-identifier', id);
      else
        helpbrowser('-name', name);
      end
    end
  end
end
%==============================================================================
