%=============================================================================
% Copyright (c) 2016-present Allan CORNET (Nelson)
%=============================================================================
% This file is part of the Nelson.
%=============================================================================
% LICENCE_BLOCK_BEGIN
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU Lesser General Public
% License as published by the Free Software Foundation; either
% version 2.1 of the License, or (at your option) any later version.
%
% Alternatively, you can redistribute it and/or
% modify it under the terms of the GNU General Public License as
% published by the Free Software Foundation; either version 2 of
% the License, or (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU Lesser General Public License for more details.
%
% You should have received a copy of the GNU Lesser General Public
% License along with this program. If not, see <http://www.gnu.org/licenses/>.
% LICENCE_BLOCK_END
%=============================================================================
function edit(varargin)
  nargin = length(varargin);
  if nargin == 0
    editor();
  else
    for v = varargin(:)'
      name = v{1};
      if ismacro(name)
        filename = which(name);
        if iscell(filename)
          finalfilename = filename{1};
        else
          finalfilename = filename;
        end
        editor(finalfilename);
      else
        finalfilename =name;
      end
      if isdir(finalfilename)
        msg = [_('Cannot edit the directory: '), finalfilename];
        error(msg)
      end
      if strcmp(fileparts(finalfilename, 'extension'), '') == true
        finalfilename = [finalfilename, '.m'];
      end
      editor(finalfilename)
    end
  end
end
%=============================================================================
